
importPackage(Packages.org.eclipse.birt.chart.model.attribute);
importPackage(Packages.org.eclipse.birt.chart.model.attribute.impl);
importPackage(Packages.org.eclipse.birt.chart.model.component.impl);
importPackage(Packages.org.eclipse.birt.chart.model.data.impl);

importPackage( Packages.org.eclipse.birt.chart.model.type.impl );
importPackage( Packages.org.eclipse.birt.chart.util);

//configuration  based on rateVar
var config={
	BSI:{
		SCA:{
			chartVarMap : {
				"numpatdays" : "numpatdays",
				"numpcldays" : "numpcldays",
				"numtcldays":"numtcldays",
				"pclabcount":"pclabcount",
				"pclabrate":"pclabrate",
				"plinedu":"plinedu",
				"tclabcount":"tclabcount",
				"tclabrate":"tclabrate",
				"tlinedu":"tlinedu"
			}
		},
		ICU:{
			chartVarMap : {
				clabcount : "bsi_count",
				clabrate : "clabrate",
				linedu:"linedu",
				numcldays:"central_line_days",
				numpatdays:"patient_days"
			}
		},
		NICU:{
			chartVarMap : {
				clab_ucabcount: {A:"clab_ucabcount_a", B:"clab_ucabcount_b", C:"clab_ucabcount_c",D:"clab_ucabcount_d",E:"clab_ucabcount_e"},
				clabcount : {A:"clabcount_a",B:"clabcount_b",C:"clabcount_c",D:"clabcount_d",E:"clabcount_e" },
				clabrate : {A:"clabrate_a", B:"clabrate_b",C:"clabrate_c",D:"clabrate_d",E:"clabrate_e"},
				linedu : {A:"linedu_a", B:"linedu_b",C:"linedu_c",D:"linedu_d",E:"linedu_e"},
				numcl_ucdays : {A:"numcl_ucdays_a", B:"numcl_ucdays_b",C:"numcl_ucdays_c",D:"numcl_ucdays_d",E:"numcl_ucdays_e"},
				numcldays : {A: "numcldays_a", B:"numcldays_b",C:"numcldays_c",D:"numcldays_d",E:"numcldays_e"},
				numpatdays : {A:"numpatdays_a", B:"numpatdays_b",C:"numpatdays_c",D:"numpatdays_d",E:"numpatdays_e"},
				numumcdays : {A:"numumcdays_a", B:"numumcdays_b",C:"numumcdays_c",D:"numumcdays_d",E:"numumcdays_e"},
				ucabcount : {A:"ucabcount_a", B:"ucabcount_b",C:"ucabcount_c",D:"ucabcount_d",E:"ucabcount_e"},
				ucabrate : {A:"ucabrate_a", B:"ucabrate_b",C:"ucabrate_c",D:"ucabrate_d",E:"ucabrate_e"},
				umbcdu : {A:"umbcdu_a", B:"umbcdu_b",C:"umbcdu_c",D:"umbcdu_d",E:"umbcdu_e"}
			}
		}
	},
	PNEU:{
		NICU:{
			chartVarMap : {
				numpatdays : {A:"numpatdays_a", B:"numpatdays_b",C:"numpatdays_c",D:"numpatdays_d",E:"numpatdays_e"},
				numventdays: {A:"numventdays_a", B:"numventdays_b", C:"numventdays_c",D:"numventdays_d",E:"numventdays_e"},
				vapcount : {A:"vapcount_a",B:"vapcount_b",C:"vapcount_c",D:"vapcount_d",E:"vapcount_e" },
				vaprate : {A:"vaprate_a", B:"vaprate_b",C:"vaprate_c",D:"vaprate_d",E:"vaprate_e"},
				ventdu : {A:"ventdu_a", B:"ventdu_b",C:"ventdu_c",D:"ventdu_d",E:"ventdu_e"}
			}
		},
		ICU:{
			chartVarMap : {
				"numpatdays" : "numpatdays",
				"numventdays" : "numventdays",
				"vapcount":"vapcount",
				"vaprate":"vaprate",
				"ventdu":"ventdu"
			}
		}
	},
	UTI:{
		ICU:{
			chartVarMap : {
				numpatdays : "numpatdays",
				cathdu : "cathdu",
				caucount:"caucount",
				caurate:"caurate",
				numcathdays:"numcathdays"
			}
		}
	},
	SSI:{
		PROC:{
			chartVarMap : {
				"ssicount" : "ssicount",
				"ssirate" : "ssirate",
				"proccount":"proccount"
			}
		},
		SURG:{
			chartVarMap : {
				"ssicount" : "ssicount",
				"ssirate" : "ssirate",
				"proccount":"proccount"
			}
		}
	},
	DE:{
		accessTypes : {
			"fistula" : { "long" :"Fistula","short":"Fistula"},
			"graft": { "long" :"Graft","short":"Graft" },
			"perm_cl": { "long" :"Perm Central Line","short":"Perm CL" },
			"temp_cl": { "long" :"Temp Central Line","short":"Temp CL" },
			"port_device": { "long" :"Port Device","short":"Port" },
			"all": { "long" :"All","short":"All" }
		},
		slctVarMaps : {
			"ABX":{"select" : "slctDERunABXVars"},
			"VANC":{"select" : "slctDERunVANCVars"},
			"LAI":{"select" : "slctDERunLAIVars"},
			"ARB":{"select" : "slctDERunABRVars"},
			"PBC":{"select" : "slctDERunPBCVars"},
			"HOSP":{"select" : "slctDERunHOSPVars"},
			"INCID":{"select" : "slctDERunINCIDVars"},
			"VAI":{"select" : "slctDERunVAIVars"}
		}
	}
}

// ======================================================
//default  V A R I A B L E S   used throughout control chart
// ======================================================
var ymax =  30;
var ymin = 0;
var refVal = null;
var yStepSize = 10;
var ySteps = 10;
var lineMarkShape = "circle"; //box
var maxNumForXInterval = 24;
var xLabelInteval = 2;
var maxNumForYInterval = 200;
var yLabelInteval = 2;
//specific for NICU uses
birthWeightCodes = {"A" :{ "short":"A", "long": "<= 750" },"B":{ "short":"B", "long":"751 - 1000"}, "C":{ "short":"C", "long": "1001 - 1500"}, "D":{ "short":"D", "long":"1501 - 2500"}, "E":{ "short":"E", "long":"> 2500"}}
accessTypes = {
	"fistula" : { "long" :"Fistula","short":"Fistula"},
	"graft": { "long" :"Graft","short":"Graft" },
	"perm_cl": { "long" :"Perm Central Line","short":"Perm CL" },
	"temp_cl": { "long" :"Temp Central Line","short":"Temp CL" },
	"port_device": { "long" :"Port Device","short":"Port" },
	"all": { "long" :"All","short":"All" }
}

/* functions to be registered and called from chart beforeRender event to customize chart elements
*  need to registered as globalvariable and called from corresponding functions in that events
*/
function customizeDataPoint(dph, fill, icsc)
{
	chart =  icsc.getChartInstance();
	min_marker = chart.getAxes().get(0).getAssociatedAxes().get(0).getMarkerLines().get(0).getValue().getValue();

	if (dph.getOrthogonalValue() <= min_marker)
		fill.set(0,255,0);
}
function getMaxDataValueInSeries(series, dataSet, icsc){
	ps = PluginSettings.instance( );
	dsp = ps.getDataSetProcessor( series.getClass() );
	mmax = dsp.getMaximum( dataSet );
	mmin = dsp.getMinimum( dataSet );
	return mmax;
}
function customizeChart(chart, icsc, customOption) {
	var log = icsc.getExternalContext().getScriptable().getPersistentGlobalVariable("log")
	var custOptions = getCustomOption(chart, icsc, customOption);

	s1		= new Array();	//
	s2		= new Array();	//
	s3		= new Array();	//
	// CHART AREA COLOR
	s1[20] = "235,233,239";

	// LINE MARKERS
	s1[91] = 2;	// Line thickness
	s1[92] = lineMarkShape;
	s1[93] = 2;	// 0 No markers

	// Y Axis Scale
	s1[400] = "true";
	s1[401] = ymin;       //min
	s1[402] = custOptions.maxY ;      //max
	//s1[403] = yStepSize;   //step and the following mutually exclusive
    s1[404] =  ySteps;         //number of step


	// Gradient
	//s1[139] = "tb";//Gradient top to bottom, with gradient, line and markers have different shade

	//Stripe Colors
	/* s1[09] = "255,255,255";
	s1[10] = "200,200,234";
*/
	// Series Labels
	s2[100] = "show";
	s2[102] = "Arial";
	s2[103] = 10;
	//s2[104] = "0,0,0"; //color?
	// s2[105] = "255,255,255";
	s2[106] = "bold";
	s2[108] = "above";
	// s2[109] = ",K,0.01,0";
	s2[101] = "0,3,0,0";

	// TITLE
	s2[01] = custOptions.reportTitle;	// CHART TITLE
	s2[07] = "n";   //title anchor n
	s2[02] = "Verdana"; //font
	s2[03] = 14;//size
	s2[04] = "81,77,92";	// COLOR
	s2[06] = "bold";	// bold
	s2[09] = "6,-6,0,0"; // Insets. Move title down a little.

	// s2[06] = "bold";
	// PLOT AREA INSETS
	s2[200] = "true";
	// Minus Left and right causes the lines to strecth the full width of the chart area
	s2[201] = "-2,0,0,5";

	// AXIS TITLES
	s2[10] = "hide";		// Hide X AXIS TITLE
	s2[20] = "hide";        //Hide Y Axis title
	// s2[21] = "Sales $";		// Y AXIS TITLE

	// X AXIS LABELS
	//s2[37] = "90"; 				// Rotate X axis labels
	s1[50] = "hide";  //X grid line
	s1[51] = 1;	// X grid lines width
	s2[33] = 8;	// X labels font size
	// s2[38] = "y";	// Stagger the labels

	s2[170] = "hide";	// Hide legend

	s3[00] = "210,0,40";		// Color 1 for line
	// Custom Palette
	s3[00] = "122,13,36";
	s3[01] = "230,141,52"
	s3[02] = "178,32,32"
	s3[03] = "142,26,26"

	cdvBuildChart(chart, icsc,s1,s2,s3);
	createReferenceLine(chart, icsc, custOptions.referenceLineVal);
	resize(chart, custOptions.maxY, custOptions.chartVariable);
	resetXLabelInterval( chart, icsc, custOptions);
	resetYLabelInterval( chart, icsc, custOptions);
}
/* supporting functions to assist in customize chart
* called directly from the aboved functions
*/
function getCustomOption( chart, icsc, custOptions){
	var customOption =  custOptions;
	customOption.rateVar = icsc.getExternalContext().getScriptable().getParameterValue("rateVar");
	var chartVariable = icsc.getExternalContext().getScriptable().getParameterValue("chartVariable");
	customOption.chartVariable = chartVariable;
	customOption.moduleSubType = icsc.getExternalContext().getScriptable().getParameterValue("moduleSubType");
	customOption.fieldLabel = icsc.getExternalContext().getScriptable().getParameterValue("fieldLabel");
	customOption.referenceLineVal = icsc.getExternalContext().getScriptable().getParameterValue("referenceLineVal");
	customOption.reportTitle = getReportTitles( chart, icsc, custOptions);
	customOption.maxY = getMaxY( chart, icsc, custOptions, chartVariable);
	return customOption;
}
function getMaxY( chart,icsc, customOptions, chartVariable){
	ymax = customOptions.referenceLineVal ? customOptions.referenceLineVal>customOptions.maxVal? customOptions.referenceLineVal : customOptions.maxVal: customOptions.maxVal;
	if(chartVariable.indexOf('du') != -1 ){
		ymax = 1; //customOptions.referenceLineVal ? ymax : 1;
	}else if(chartVariable.indexOf('count') != -1 || chartVariable.indexOf('days') != -1  || chartVariable.indexOf('pats') != -1  ){
		//ymax = customOptions.maxVal;
		ymin = customOptions.minVal;
		//ymax = parseInt(BirtMath.ceiling((ymax-ymin)/ySteps, 1))* ySteps;
		if((ymax-ymin > ySteps) &&(ymax-ymin)%ySteps != 0 ){
			yStepSize = parseInt(Math.round((ymax-ymin)/ySteps) )+1;
			ymax = yStepSize * (ySteps) + parseInt(ymin);
		} else if(((ymax-ymin) < ySteps) &&(ymax-ymin)%ySteps != 0){
			ymax = ySteps;//which is 10
			yStepSize = 1;
		}
		else if(ymax==ymin){
			//yStepSize = parseInt(Math.round((ymax-ymin)/ySteps) );
			ymax = parseInt(ymin) + 10;//which is 10
		}
	}else{
		ymax = ymax <= 30 ? 30 : ymax;
		yStepSize = parseInt(Math.round((ymax-ymin)/ySteps) );
		if((ymax > ySteps) &&(ymax)%ySteps != 0 ){
			yStepSize = parseInt(Math.round((ymax)/ySteps) );
			ymax = yStepSize * (ySteps+1);
		} else if((ymax> ySteps) &&(ymax)%ySteps == 0){
			yStepSize = parseInt(Math.round((ymax)/ySteps) );
			if(ymax != 30 )
        ymax = yStepSize * (ySteps+1);
		}
	}
	/*if(max % yStepSize != 0 )
		max = parseInt((Math.round( (max-ymin)/yStepSize ) + 1)* yStepSize);
	if( max == customOptions.maxVal || max == customOptions.referenceLineVal )
		max = parseInt(max) + parseInt(yStepSize);*/
	return ymax;
}
function getReportTitles (chart, icsc, customOptions){
	var title = "=" + icsc.getExternalContext().getScriptable().getPersistentGlobalVariable("chartVarDesc")
	if(customOptions.moduleSubType == 'DE'){
		var accessTypeCode  = icsc.getExternalContext().getScriptable().getPersistentGlobalVariable("accessTypeCode");
       	var label = accessTypes[ accessTypeCode ][ customOptions.fieldLabel ];
		var accessTypeLabel = icsc.getExternalContext().getScriptable().getPersistentGlobalVariable("accessType");
		title = title + "\n" + accessTypeLabel.replace("{0}", label);
	}
	else{
		if(customOptions.rateVar == 'NICU'){
			var birthWeighCode  = icsc.getExternalContext().getScriptable().getPersistentGlobalVariable("birthWeighCode");
			var label = birthWeightCodes[ birthWeighCode ][ customOptions.fieldLabel ]
			var birthWeightLabel = icsc.getExternalContext().getScriptable().getPersistentGlobalVariable("birthWeight");
			title = title + "\n" + birthWeightLabel.replace("{0}", label);
		}
	}
	return title;
}
function createReferenceLine(chart, icsc, refVal){
	if( refVal ){
		var chart = icsc.getChartInstance();
		var yAxis = chart.getAxes().get(0).getAssociatedAxes().get(0);
		min_ml = MarkerLineImpl.create(yAxis, NumberDataElementImpl.create(refVal));
		min_ml.getLabel().getCaption().setValue("");
		min_ml.getLabel().setVisible(false);  // Hide line label
		min_ml.getLineAttributes().getColor().set(255,0,0);
	}
}
function resetXLabelInterval( chart, icsc, customOptions){
	xAxis = chart.getBaseAxes()[0];
	yAxis = chart.getOrthogonalAxes( xAxis, true)[0];
	seriesDef = yAxis.getSeriesDefinitions().get(0);
	runSeries = seriesDef.getRunTimeSeries()[0];
	//Retrieve list of data values
	list = runSeries.getDataSet().getValues();
	if(list.length >= maxNumForXInterval )
		xAxis.setInterval(xLabelInteval );
}
function resetYLabelInterval( chart, icsc, customOptions){
	xAxis = chart.getBaseAxes()[0];
	yAxis = chart.getOrthogonalAxes( xAxis, true)[0];
	if( parseInt(customOptions.maxY) >= parseInt(maxNumForYInterval) )
		yAxis.setInterval(yLabelInteval );
}
function resize(chart, maxY, chartVariable){
	xAxis = chart.getBaseAxes()[0];
	yAxis = chart.getOrthogonalAxes( xAxis, true )[0];
	seriesDef = yAxis.getSeriesDefinitions().get(0);
	runSeries = seriesDef.getRunTimeSeries()[0];
	//Retrieve list of data values
	list = runSeries.getDataSet().getValues();
	chart.getBlock().getBounds().setHeight(250);
	
	if( list.length > 24){
		chart.getBlock().getBounds().setWidth(900);
	}else{
		chart.getBlock().getBounds().setWidth(700);
	}
}
