
importPackage(Packages.java.util.logging);
importPackage(Packages.javax.swing);

// Call function to initialize logging
initializeLogger();

/**************************************************
 * Name:		initializeLogger
 * Description:	Initializes logger variables
 * 				NOTE: This method can be customized
 * 					  to use a Logger passed in 
 * 					  through the reportContext or
 * 					  another type of custom
 * 					  Java Class
 * Parameters:	string value
 * Returns:		true/false 
 **************************************************/
function initializeLogger() {
	// Log File Location
	logFilePath = "birt-reports.log";
	//logFilePath = "logs\\birt-reports.log";
	// Logger Name
	loggerName = "Ess";
	// Enable/Disable Logging
	blnLogging = true;
	// log file size limit (5mb)
	logFileSizeLimit = 5000000;
	// number of log files
	numOfLogFiles = 1;
	
	if(blnLogging) {
		// Create a file handler that uses 5 logfiles, 
		// FileHandler fh = new FileHandler(pattern, limit, numLogFiles); 
		
		//fileHandler = new FileHandler(logFilePath, true);
	//todorovp - turning file logging off because of consistent problems with permissions
	/*
	 fileHandler = new FileHandler(logFilePath, logFileSizeLimit, numOfLogFiles, true);
		
		// NOTE: This variable could use a Logger object 
		//		 passed in through the Report Context.
		//		 Or, it could refer to another custom
		//		 Java Object
		reportLogger = Logger.getLogger(loggerName);
		reportLogger.addHandler(fileHandler);
	*/
	}
}

/**************************************************
 * Name:		logMessageInfo
 * Description:	logs info messages
 * Parameters:	string message
 * Returns:		
 **************************************************/
function logMessageInfo(strMessage) {
	if(blnLogging)
		reportLogger.info("**INFO: " + strMessage);
}

/**************************************************
 * Name:		logMessageWarning
 * Description:	logs warning messages
 * Parameters:	string message
 * Returns:		
 **************************************************/
function logMessageWarning(strMessage) {
	if(blnLogging)
		reportLogger.warning("**WARNING: " + strMessage);
}

/**************************************************
 * Name:		logMessageSevere
 * Description:	logs severe messages
 * Parameters:	string message
 * Returns:		
 **************************************************/
function logMessageSevere(strMessage) {
	if(blnLogging)
		reportLogger.severe("**SEVERE: " + strMessage);
}


